mod Ex08a

incl Mtex

incl Maux

loc rem 
  \para \bf  8. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 4.4.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie pomocnych funkcii 
         a predikatov. 
   \item \para Subor(y) \it  ex08*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Braun Trees.  \end See also the section \it  Perfectly 
  Balanced Binary Trees  \end. 

rem 
  \para \bf  Braun trees.  \end 

pred/2 Index 
  Index(0,Nd(x,l,r))
  Index(S1(i),Nd(x,l,r)) <- Index(i,l)
  Index(S2(i),Nd(x,l,r)) <- Index(i,r)

pred Brt 
  Brt(t) <-> Bt(t) & \a i(Index(i,t) <-> i < Sz(t))

rem 
  \para We have 
  \eq* 
    Brt(E)
  \end
  \eq* 
    Brt Nd(x,l,r) <-> (Sz(l) = Sz(r) \/ Sz(l) = Sz(r)+1) & Brt(l) & Brt(r)
  \end

rem 
  \para \bf  Indexing in Braun trees.  \end 

fun/2 Lookup 'Tex2_bappl1'
  Lookup(t,i) = Foo

rem 
  \para \bf  Modification of Braun trees.  \end 
  \header* fun/3 Update 'Tex_f3_bt_update' \end Define the function 
  \ft Update(t,i,x) \end such that 
  \eq* 
    Brt(t) & i < Sz(t) -> Brt Update(t,i,x)
  \end
  \eq* 
    Brt(t) & i < Sz(t) -> Sz Update(t,i,x) = Sz(t)
  \end
  \eq* 
    Brt(t) & i < Sz(t) -> Lookup(Update(t,i,x),i) = x
  \end
  \eq* 
    Brt(t) & i < Sz(t) & j < Sz(t) & j != i -> 
    Lookup(Update(t,i,x),j) = Lookup(t,j)
  \end

fun/3 Update 'Tex_f3_bt_update'
  Update(t,i,x) = Foo

rem 
  \para \bf  New Braun tree.  \end Define the function \ft New(n) \end such that 
  \eq* 
    Brt New(n)
  \end
  \eq* 
    Sz New(n) = n
  \end

fun New 
  New(n) = Foo

rem 
  \para \bf  Filling a Braun tree.  \end \header* fun/2 Fill  \end Define the 
  function \ft Fill(n,x) \end such that 
  \eq* 
    Brt Fill(n,x)
  \end
  \eq* 
    Sz Fill(n,x) = n
  \end
  \eq* 
    i < n -> Lookup(Fill(n,x),i) = x
  \end

fun/2 Fill 
  Fill(n,x) = Foo

rem 
  \para \bf  Insertion of a new first label.  \end \header* fun/2 Insfirst  \end 
  Define the function \ft Insfirst(x,t) \end such that 
  \eq* 
    Brt(t) -> Brt Insfirst(x,t)
  \end
  \eq* 
    Brt(t) -> Sz Insfirst(x,t) = Sz(t)+1
  \end
  \eq* 
    Brt(t) -> Lookup(Insfirst(x,t),0) = x
  \end
  \eq* 
    Brt(t) & i < Sz(t) -> Lookup(Insfirst(x,t),i+1) = Lookup(t,i)
  \end

fun/2 Insfirst 
  Insfirst(x,t) = Foo

rem 
  \para \bf  Deletion of the first label.  \end Define the function 
  \ft Delfirst(t) \end such that 
  \eq* 
    Brt(t) & t != E -> Brt Delfirst(t)
  \end
  \eq* 
    Brt(t) & t != E -> Sz Delfirst(t)+1 = Sz(t)
  \end
  \eq* 
    Brt(t) & t != E & i+1 < Sz(t) -> Lookup(Delfirst(t),i) = Lookup(t,i+1)
  \end

fun Delfirst 
  Delfirst(t) = Foo

rem 
  \para \bf  Insertion of a new last label.  \end \header* fun/3 Inslast  \end 
  Define the function \ft Inslast(n,t,x) \end such that 
  \eq* 
    Brt(t) -> Brt Inslast(Sz(t),t,x)
  \end
  \eq* 
    Brt(t) -> Sz Inslast(Sz(t),t,x) = Sz(t)+1
  \end
  \eq* 
    Brt(t) & i < Sz(t) -> Lookup(Inslast(Sz(t),t,x),i) = Lookup(t,i)
  \end
  \eq* 
    Brt(t) -> Lookup(Inslast(Sz(t),t,x),Sz(t)) = x
  \end

fun/3 Inslast 
  Inslast(n,t,x) = Foo

rem 
  \para \bf  Deletion of the last label.  \end \header* fun/2 Dellast  \end 
  Define the function \ft Dellast(n,t) \end such that 
  \eq* 
    Brt(t) & t != E -> Brt Dellast(Sz(t)-1,t)
  \end
  \eq* 
    Brt(t) & t != E -> Sz Dellast(Sz(t)-1,t) = Sz(t)-1
  \end
  \eq* 
    Brt(t) & t != E & i < Sz(t)-1 -> Lookup(Dellast(Sz(t)-1,t),i) = Lookup(t,i)
  \end

fun/2 Dellast 
  Dellast(n,t) = Foo

rem 
  \para \bf  Quick computation of the size for Braun trees.  \end 

fun Sz1 'Tex_f1_bt_sz'
  Sz1(t) = Foo

rem 
  \para \bf  Converting lists into Braun trees.  \end Define the function 
  \ft Ln2brt(x) \end such that 
  \eq* 
    Brt Ln2brt(x)
  \end
  \eq* 
    Sz Ln2brt(x) = L(x)
  \end
  \eq* 
    i < L(x) -> Lookup(Ln2brt(x),i) = Sub(x,i)
  \end

fun Ln2brt 
  Ln2brt(x) = Foo

rem 
  \para \bf  Converting Braun trees into lists.  \end Define the function 
  \ft Brt2ln(t) \end such that 
  \eq* 
    Brt(t) -> L Brt2ln(t) = Sz(t)
  \end
  \eq* 
    Brt(t) & i < Sz(t) -> Sub(Brt2ln(t),i) = Lookup(t,i)
  \end

fun Brt2ln 
  Brt2ln(t) = Foo

