mod Ex08b

incl Mtex

incl Maux

incl Ex08a

loc rem 
  \para \bf  8. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 4.4.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie pomocnych funkcii 
         a predikatov. 
   \item \para Subor(y) \it  ex08*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

appldisp/2 Tex_f2_char_eqf
  Infix(Arg(0),20,0,Subsup(Op('=',0),75,Op('*',0),None),Arg(1))

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Counting the labels in binary trees.  \end 
  \header* fun/2 Count 'Tex_f2_ln_count' \end The function \ft Count(x,t) \end 
  counts the number of nodes of the binary tree \ft t \end labelled by the 
  number \ft x \end. 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

fun/2 Count 'Tex_f2_ln_count'
  Count(x,E) = 0
  Count(x,Nd(y,l,r)) = Count(x,l)+Count(x,r)+Eqf(x,y)

rem 
  \para \bf  Section. Braun Trees.  \end See the module \it  Ex08a  \end. 

rem 
  \para \bf  Section. Applications of Trees.  \end 

rem 
  \para \bf  Subsection. Heaps and Priority Queues.  \end 

rem 
  \para \bf  Heaps.  \end 

pred/2 Ge 'Tex2_succeq'
  Ge(x,t) <-> \a y(Inbt(y,t) -> x >= y)

pred Heap 
  Heap(t) <-> Brt(t) & \a x\a l\a r(Subtree(Nd(x,l,r),t) -> Ge(x,l) & Ge(x,r))

rem 
  \para We have 
  \eq* 
    Heap(E)
  \end
  \eq* 
    Heap Nd(x,l,r) <-> 
    (Sz(l) = Sz(r) \/ Sz(l) = Sz(r)+1) & Ge(x,l) & Ge(x,r) & Heap(l) & Heap(r)
  \end

rem 
  \para \bf  Priority queues.  \end Numbers of the form \ft n,t \end such that 
  \eq* 
    Heap(t) & n = Sz(t)
  \end
  \para are called priority queues. 

rem 
  \para \bf  Upheap.  \end \header* fun/3 Upheap  \end Define the function 
  \ft Upheap(n,t,x) \end such that 
  \eq* 
    Heap(t) -> Heap Upheap(Sz(t),t,x)
  \end
  \eq* 
    Heap(t) -> Sz Upheap(Sz(t),t,x) = Sz(t)+1
  \end
  \eq* 
    Heap(t) -> Count(y,Upheap(Sz(t),t,x)) = Count(y,t)+Eqf(y,x)
  \end

fun/3 Upheap 
  Upheap(n,t,x) = Foo

rem 
  \para \bf  Insertion in priority queues.  \end \header* fun/3 Enqueue  \end 
  Define the function \ft Enqueue(n,t,x) \end such that 
  \eq* 
    Heap(t) -> \e n1\e t1 Enqueue(Sz(t),t,x) = n1,t1
  \end
  \eq* 
    Heap(t) & Enqueue(Sz(t),t,x) = n1,t1 -> Heap(t1) & n1 = Sz(t1)
  \end
  \eq* 
    Heap(t) & Enqueue(Sz(t),t,x) = n1,t1 -> Sz(t1) = Sz(t)+1
  \end
  \eq* 
    Heap(t) & Enqueue(Sz(t),t,x) = n1,t1 -> Count(y,t1) = Count(y,t)+Eqf(y,x)
  \end

fun/3 Enqueue 
  Enqueue(n,t,x) = Foo

rem 
  \para \bf  Downheap .  \end \header* fun/2 Downheap  \end Define the function 
  \ft Downheap(t,x) \end such that 
  \eq* 
    Heap(t) & t != E -> Heap Downheap(t,x)
  \end
  \eq* 
    Heap(t) & t != E -> Sz Downheap(t,x) = Sz(t)
  \end
  \eq* 
    Heap(t) & t != E -> 
    Count(y,Downheap(t,x))+Eqf(y,Lookup(t,0)) = Count(y,t)+Eqf(y,x)
  \end

fun/2 Downheap 
  Downheap(t,x) = Foo

rem 
  \para \bf  Deletion in priority queues.  \end \header* fun/2 Dequeue  \end 
  Define the function \ft Dequeue(n,t) \end such that 
  \eq* 
    Heap(t) & t != E -> \e n1\e t1 Dequeue(Sz(t),t) = n1,t1
  \end
  \eq* 
    Heap(t) & t != E & Dequeue(Sz(t),t) = n1,t1 -> Heap(t1) & n1 = Sz(t1)
  \end
  \eq* 
    Heap(t) & t != E & Dequeue(Sz(t),t) = n1,t1 -> Sz(t1)+1 = Sz(t)
  \end
  \eq* 
    Heap(t) & t != E & Dequeue(Sz(t),t) = n1,t1 -> 
    Count(x,t1)+Eqf(x,Lookup(t,0)) = Count(x,t)
  \end

fun/2 Dequeue 
  Dequeue(n,t) = Foo

rem 
  \para \bf  Subsection. Sorting of Braun trees.  \end 

rem 
  \para \bf  Permutations.  \end 

pred/2 Perm 'Tex2_sim'
  Perm(t1,t2) <-> \a x Count(x,t1) = Count(x,t2)

rem 
  \para \bf  Ordered trees.  \end 

pred Ord 
  Ord(t) <-> 
    \a i\a j(Index(i,t) & Index(j,t) & i < j -> Lookup(t,i) <= Lookup(t,j))

rem 
  \para Note that we have 
  \eq* 
    Brt(t) -> Ord(t) <-> 
    \a i\a j(i < j & j < Sz(t) -> Lookup(t,i) <= Lookup(t,j))
  \end

rem 
  \para \bf  Exercise.  \end Define the function \ft Brt2q(t) \end such that 
  \eq* 
    Heap(t) -> \e n1\e t1 Brt2q(t) = n1,t1
  \end
  \eq* 
    Heap(t) & Brt2q(t) = n1,t1 -> Heap(t1) & n1 = Sz(t1)
  \end
  \eq* 
    Heap(t) & Brt2q(t) = n1,t1 -> Perm(t1,t)
  \end

fun Brt2q 
  Brt2q(t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Q2brt  \end Define the function 
  \ft Q2brt(n,t) \end such that 
  \eq* 
    Heap(t) -> Brt Q2brt(Sz(t),t)
  \end
  \eq* 
    Heap(t) -> Perm(Q2brt(Sz(t),t),t)
  \end
  \eq* 
    Heap(t) -> Ord Q2brt(Sz(t),t)
  \end

fun/2 Q2brt 
  Q2brt(n,t) = Foo

rem 
  \para \bf  Heapsort.  \end Implement heapsort on Braun trees; that is, define 
  the function \ft Hsort(t) \end such that 
  \eq* 
    Brt(t) -> Brt Hsort(t)
  \end
  \eq* 
    Brt(t) -> Perm(Hsort(t),t)
  \end
  \eq* 
    Brt(t) -> Ord Hsort(t)
  \end
  \para with the help of the functions \ft Brt2q(t) \end and 
  \ft Q2brt(n,t) \end. 

fun Hsort 
  Hsort(t) = Foo

